// copyright 2012 NS BASIC Corporation. All rights reserved.

//if(typeof(NSB)==="undefined"){NSB={}}

var NSB = {
	alertDialog: null,

	msgboxDefaultRtn: function(buttonClicked, inputTxt) {},
	
	MsgBox: function(rtnFunc, prompt, buttons, title) {
		if (typeof(rtnFunc)!='function' && !title){ //looking for less than 4 parameters
			title=buttons; buttons=prompt; prompt=rtnFunc; rtnFunc=NSB.msgboxDefaultRtn;}
		var imgicon = NSB._parseIcon(buttons);
		if (!prompt || prompt==null || typeof(prompt)=='undefined') { prompt = ''; }
		if (title==null || typeof(title)=='undefined') { title = document.title; }
		if (title=='') title=' ';
		if (!buttons || buttons==null || typeof(buttons)=='undefined') { buttons = '0'; }
		if (!rtnFunc || rtnFunc==null || typeof(rtnFunc)=='undefined' || typeof(rtnFunc) != 'function' || rtnFunc=='') { rtnFunc=NSB.msgboxDefaultRtn; }
		buttonObj = NSB._parseButtons(buttons, rtnFunc);

		if (!this.alertDialog) {
			this.alertDialog = new Dialog({ //default options
				//top: 140,
				width: 281,
				title: title,
				icon: imgicon,
				content: prompt,
				icontent: '',
				buttons: buttonObj,
				openOnCreate: false,
				destroyOnClose: true //jw destroy on any button click
			});
		}
		this.alertDialog.open();
 	},

	closeMsgBox: function() { if (this.alertDialog) {this.alertDialog.close();} },

	InputBox: function(rtnFunc, prompt, title, def, xpos, ypos) {
		if (!prompt || prompt==null || typeof(prompt)=='undefined') { prompt = ''; }
		if (title==null || typeof(title)=='undefined') { title = document.title; }
		if (!rtnFunc || rtnFunc==null || typeof(rtnFunc)=='undefined' || rtnFunc=='') { rtnFunc=NSB.msgboxDefaultRtn; }
		if (!def || def==null || typeof(def)=='undefined' || def=='') { def = null; }

		var dialog = new Dialog({
			title: title,
			icon: '',
			content: prompt,
			icontent: def,
			buttons: {
					'Cancel': function() {
					this.close();
					rtnFunc(2,'');
				},
					'OK': function() {
					var iboxValue = document.getElementById('_nsbDialogBoxInput');
					var inputText = iboxValue.value;
					this.close();
					rtnFunc(1,inputText);
				}
			},
			close: function() {this.close();}
		});
		this.alertDialog = dialog;
	},

	//parses button types
	_parseButtons: function(buttons, rtnFunc) {
		if (buttons == "") buttons = "0";
		var buttonObj = '';
		//test if buttons parameter numeric
		if (buttons == parseInt(buttons) && buttons == parseFloat(buttons)) {
			//determine button from vbscript value: modal 0xF000, default 0x0F00, icon 0x00F0, button 0x000F
			
			// 0 = vbOKOnly - OK button only
			// 1 = vbOKCancel - OK and Cancel buttons
			// 2 = vbAbortRetryIgnore - Abort, Retry, and Ignore buttons
			// 3 = vbYesNoCancel - Yes, No, and Cancel buttons
			// 4 = vbYesNo - Yes and No buttons
			// 5 = vbRetryCancel - Retry and Cancel buttons
			var buttonCombination = buttons & 0x000F;
			
			// 0 = vbDefaultButton1 - First button is default
			// 256 = vbDefaultButton2 - Second button is default
			// 512 = vbDefaultButton3 - Third button is default
			// 768 = vbDefaultButton4 - Fourth button is default
			var buttonDefault = buttons & 0x0F00;
			
			// 0 = vbApplicationModal - Application modal (the current application will not work until the user responds to the message box)
			// 4096 = vbSystemModal - System modal (all applications wont work until the user responds to the message box)
			var buttonMode = buttons & 0xF000;

			switch (buttonCombination) {
				case 1: //vbOKCancel - OK (1) and Cancel (2) buttons
					buttonObj={'OK': function() {this.close(); rtnFunc(1,'');},'Cancel': function() {this.close(); rtnFunc(2,'');}};
					break;
				case 2: //vbAbortRetryIgnore - Abort (3), Retry (4), and Ignore (5) buttons
					buttonObj={'Abort': function() {this.close(); rtnFunc(3,'');},'Retry': function() {this.close(); rtnFunc(4,'');},'Ignore': function() {this.close(); rtnFunc(5,'');}};
					break;
				case 3: //vbYesNoCancel - Yes (6), No (7), and Cancel (2) buttons
					buttonObj={'Yes': function() {this.close(); rtnFunc(6,'');},'No': function() {this.close(); rtnFunc(7,'');},'Cancel': function() {this.close(); rtnFunc(2,'');}};
					break;
				case 4: //vbYesNo - Yes (6) and No (7) buttons
					buttonObj={'Yes': function() {this.close(); rtnFunc(6,'');},'No': function() {this.close(); rtnFunc(7,'');}};
					break;
				case 5: //vbRetryCancel - Retry (4) and Cancel (2) buttons
					buttonObj={'Retry': function() {this.close(); rtnFunc(4,'');},'Cancel': function() {this.close(); rtnFunc(2,'');}};
					break;
				default: //0 = vbOKOnly - OK (1) button only
					buttonObj={'OK': function() {this.close(); rtnFunc(1,'');}};
					break;
			}
		} else {
			//not numeric so custom buttons
			var customButtonParams = buttons.split(";"); //separate button values from icon value
			var customButton = customButtonParams[0].split(","); //get button values
			
			var cbutton=[];
			for(i=0; i<customButton.length; i++) {
				var appendType = (i==0?true:false); //insert first one then append others
				cbutton[i] = customButton[i]+": function() {this.close(); rtnFunc('"+customButton[i]+"','');}"
				if (i != customButton.length-1) { cbutton[i] += ','; }
			}
			var cbuttonObj='';
			for(i=0; i<customButton.length; i++) { cbuttonObj += cbutton[i]; }
			eval("buttonObj={"+cbuttonObj+"};");
		}
		return buttonObj;
 	},

	//parses icon types
	_parseIcon: function(buttons) {
		if (typeof(buttons)=="undefined") buttons=0;
		if (buttons == "") buttons = 0;
		//test if buttons parameter numeric
		var imgIcon = '';
		if (buttons == parseInt(buttons) && buttons == parseFloat(buttons)) {
			//determine button from vbscript value: modal 0xF000, default 0x0F00, icon 0x00F0, button 0x000F
			
			// 16 = vbCritical - Critical Message icon
			// 32 = vbQuestion - Warning Query icon
			// 48 = vbExclamation - Warning Message icon
			// 64 = vbInformation - Information Message icon
			imgIcon = buttons & 0x00F0;
		} else {
			//not numeric so custom buttons
			var customButtonParams = buttons.split(";"); //separate button values from icon value
			if (customButtonParams.length > 1) { imgIcon=customButtonParams[1]; } //icon can be vbScript type or custom path
		}
		
		imgIcon = imgIcon + ""; //force string conversion
		if (!imgIcon || imgIcon==null || imgIcon.replace(/\s+/g,'')=='') { imgIcon=''; }
		if (imgIcon.length > 2) {
			imgIcon=imgIcon.replace(/\'/g,"''").replace(/\"/g,'""');
			imgIcon="<img src='"+imgIcon+"' width='33' height='33' border='0'>";
			//source string of custom image
		} else {
			switch (imgIcon) { //must begin with "*" to denote system icon to calling function
				case '16': imgIcon="*criticalicon"; break;
				case '32': imgIcon="*questionicon"; break;
				case '48': imgIcon="*exclamationicon"; break;
				case '64': imgIcon="*informationicon"; break;
				default: imgIcon=""; break;
			}
		}
		return imgIcon;
	}
}

// Utility functions
function bindEventHandler(element, eventName, handler) {
	if (element.addEventListener) {
		element.addEventListener(eventName, handler, false);
	} else if (element.attachEvent) {
		element.attachEvent("on" + eventName, handler); //IE is onclick //jw
	} else {
		element["on" + eventName] = handler;
	} 		
}

/**
 * The modal dialog class
 * @constructor
 */
function Dialog(options) {
	this.options = {
		width: 281,
		//top: 140,
		openOnCreate: true,
		destroyOnClose: true,
		escHandler: this.close
	};
	// Overwrite the default options
	for (var option in options) {
		this.options[option] = options[option];
	}
	// Create dialog dom
	this._makeNodes();
	if (this.options.openOnCreate) {
		this.open();
	}
}

Dialog.prototype = {
	/* handles to the dom nodes */
	header: null,
	body: null,
	icon: null,
	content: null,
	icontent: null,
	buttonbar: null,
	wrapper: null,
	_overlay: null,
	_wrapper: null,
	_zIndex: 0,
	_escHandler: null,
	
	// Shows the dialog
	open: function() {
		this._makeTop();
		var ws = this._wrapper.style;
		ws.left = (document.body.clientWidth - this.options.width) / 2 + 'px';
		ws.position="fixed";
		ws.top="60px";
		this._overlay.style.display = 'block';
		ws.display = 'block';
		this._wrapper.focus();

		if (this.options.focus) {
			var input = document.getElementById(this.options.focus);
			if (input) {
				input.focus();
			}
		}
	},
	
	close: function() {
		if (this.options.destroyOnClose) {
			this._destroy();
			NSB.alertDialog=null; //remove the alertDialog since object destroyed //jw
		} else {
			this._overlay.style.display = 'none';
			this._wrapper.style.display = 'none';
		}
	},

	addButtons: function(buttons, prepend) {
		var buttonbar = this.buttonbar;
		var buttonArray = this._makeButtons(buttons);
		var first = null;
		if (prepend && (first = buttonbar.firstChild) != null) {
			for (var i in buttonArray) {
				buttonbar.insertBefore(buttonArray[i], first);
			}
		} else {
			for (var i in buttonArray) {
				buttonbar.appendChild(buttonArray[i]);
			}
		}
	},

	 //Makes the dom tree for the dialog
	_makeNodes: function() {
		if (this._wrapper || this.overlay) {
			return; // Avoid duplicate invocation
		}
		// Make overlay
		this._overlay = document.createElement('div');
		this._overlay.className = 'dialog-overlay';
		document.body.appendChild(this._overlay);

		// build header display
		if (typeof this.options.title == 'string' && this.options.title != '') {
			var header = document.createElement('div');
			header.className = 'dialog-header';
			header.innerHTML = this.options.title;
			this.header = header;
		}

		//build icon display
		var icon = document.createElement('div');
		if (this.options.icon.substring(0,1)=='*') {
			icon.className = 'dialog-icon';
			icon.id = this.options.icon.substring(1); //system icon
		} else {
			icon.className = 'dialog-icon-c';
			icon.innerHTML = this.options.icon; //custom icon
		}
		this.icon = icon;

		//build text display
		var content = document.createElement('div');
		if (this.options.icon != '') {
			content.className = 'dialog-itext';
		} else {
			content.className = 'dialog-text';
		}
		this.options.content=this.options.content.replace(/(\r\n)+/g,'<br>');
		this.options.content=this.options.content.replace(/(\n)+/g,'<br>');
		this.options.content=this.options.content.replace(/(\r)+/g,'<br>');
		content.innerHTML = this.options.content;
		this.content = content;

		// build button bar
		var buttonbar = document.createElement('div');
		var buttons = this._makeButtons(this.options.buttons);
		buttonbar.className = 'dialog-buttonbar';
		for (var i=0; i<buttons.length; i++) 
			buttonbar.appendChild(buttons[i]);
		this.buttonbar = buttonbar;

		var dialogContent = document.createElement('div')
		dialogContent.className = 'dialog-content';
		if (this.options.icon != '') {
			dialogContent.appendChild(icon);
		}
		
		dialogContent.appendChild(content);
		if (this.options.icontent != '') {
			var icont = document.createElement('input');
			icont.id = '_nsbDialogBoxInput';
			icont.type = 'text';
			icont.value = this.options.icontent;
			icont.text = icont.value;
			if (navigator.appVersion.indexOf('Chrome')==-1) icont.style.width = '90%';
			dialogContent.appendChild(icont);
		}
		
		var wrapper = document.createElement('div');
		wrapper.className = 'dialog-wrapper';
		var ws = wrapper.style;
		ws.position = 'absolute';
		ws.display = 'none';
		ws.outline = 'none';

		if (this.header) {
			wrapper.appendChild(header);
		}
		wrapper.appendChild(dialogContent);
		wrapper.appendChild(buttonbar);

		if (this.options.escHandler) {
			wrapper.tabIndex = -1;
			this._onKeydown = this._makeHandler(function(e) {
				if (!e) {
					e = window.event;
				}
				if (e.keyCode && e.keyCode == 27) {
					this.options.escHandler.apply(this);
				}
			}, this);
			bindEventHandler(wrapper, 'keydown', this._onKeydown);
		}
		this._wrapper = document.body.appendChild(wrapper);
	},
	
	_makeButtons: function(buttons) {
		var buttonArray = new Array();
		var buttonCount=0; //button counter
		var buttonTotal=0; //button total
		var buttonWidth=0; //button width
		for (var buttonText in buttons) { buttonTotal++; }
		
		for (var buttonText in buttons) {
			var button = document.createElement('button');
			button.className = 'dialog-buttonNoBorder';
			switch (buttonTotal) {
				case 1: buttonWidth='263px'; break;
				case 2: buttonWidth='128px'; break;
				case 3: buttonWidth='83px'; break;
				default: buttonWidth=parseInt(260/buttonTotal-1)+'px'; break; //compute button width
			}
			button.style.width = buttonWidth;

			if (buttonCount%2 == 0) { //even: 0, 2, 4, ...
				if (buttonTotal <=2) {
					button.style.margin = "0px 1px 0px 0px";
				} else {
					if (buttonCount == 0) {
						button.style.margin = "0px 2px 0px 1px";
					} else if (buttonCount == buttonTotal-1) {
						button.style.margin = "0px 0px 0px 2px";
					} else {
						button.style.margin = "0px 2px 0px 2px";
					}
				}
			} else {
				if (buttonTotal <=2) {
					button.style.margin = "0px 0px 0px 2px";
				} else {
					if (buttonCount == buttonTotal-1) {
						button.style.margin = "0px 0px 0px 1px";
					} else {
						button.style.margin = "0px 2px 0px 2px";
					}
				}
			}
			button.innerHTML = buttonText;
			bindEventHandler(button, 'click', this._makeHandler(buttons[buttonText], this));
			buttonArray.push(button);
			buttonCount++;
		}
		return buttonArray;
	},	
	
	_makeHandler: function(method, obj) {
		return function(e) {
			method.call(obj, e);
		}
	},

	_makeTop: function() {
		if (this._zIndex < Dialog.Manager.currentZIndex) {
			this._overlay.style.zIndex = Dialog.Manager.newZIndex();
			this._zIndex = this._wrapper.style.zIndex = Dialog.Manager.newZIndex();
		}
	},

	_destroy: function() {
		document.body.removeChild(this._wrapper);
		document.body.removeChild(this._overlay);
		this.header = null;
		this.body = null;
		this.icon = null;
		this.content = null;
		this.buttonbar = null;
		this.wrapper = null;
		this._overlay = null;
		this._wrapper = null;
	}
};

Dialog.Manager = {
	currentZIndex: 3000,
	newZIndex: function() {
		return ++this.currentZIndex;
	}
};
